const query = require("../db.js");
const { toSnakeCase } = require("./utils.js");

const transactionsByPostDate = async (req, res) => {
  try {
    const { startDate, endDate } = req.query;
    const tableName = "osiAccountTransactions";
    const dBtableName = toSnakeCase(tableName);

    const tableCheck = await query(`
      SELECT EXISTS (SELECT 1 FROM pg_tables WHERE tablename = $1)
      AS table_exists`, [dBtableName]);
    if (!tableCheck.rows[0]["table_exists"]) {
      return res.status(404).json({ error: `Data collection ${tableName} not found.` });
    }
    
    const result = await query(`
    SELECT data
    FROM ${dBtableName}
    WHERE post_date BETWEEN $1 and $2
    ORDER BY post_date`, [startDate, endDate]);
    const data = result.rows.map(row => row.data);
    res.status(200).json(data);

  } catch (err) {
    console.error("Error handling the request:", err);
    res.status(500).json({ error: "An error occurred while processing the request" });
  }
};

module.exports = transactionsByPostDate;
